<template>
  <frame :modal="modal">
    <headline>Create workspace</headline>

    <div class="mx-8 flex flex-row items-center">
      <colors-indicator :value="workspace.color" @input="workspace.color = $event" />
      <inputt
        placeholder="Choose a name"
        ref="inputtRef"
        type="text"
        @enter="create()"
        :value="workspace.name"
        @input="workspace.name = $event"
      ></inputt>
    </div>

    <actions>
      <cancel-action @click="modal.hide()"></cancel-action>
      <action @click="create()"> Create <i class="feather icon-check ml-2"></i> </action>
    </actions>
  </frame>
</template>

<script lang="ts">
import Inputt from "@/components/Inputt.vue";
import { isModal } from "@/use/modal";
import { onMounted, ref, watch, nextTick } from "vue";
import Workspace from "@/models/Workspace";
import ColorsIndicator from "@/components/Colors/Indicator.vue";

export default {
  components: { Inputt, ColorsIndicator },
  mixins: [isModal()],
  emits: ["created"],
  setup(props, context) {
    const inputtRef = ref<HTMLElement | null>(null);
    const workspace = ref(new Workspace());

    watch(
      () => props.modal.state.show,
      value => {
        if (value) {
          nextTick(() => inputtRef.value!.focus());
        }
      }
    );

    return {
      workspace,
      create: async () => {
        await workspace.value.save();
        workspace.value = new Workspace();
        context.emit("created");
        props.modal.hide();
      },
      inputtRef
    };
  }
};
</script>
